//-------------------------------------------------------------
void sendNTPpacket(IPAddress& address) {
 
  memset(packetBuffer, 0, NTP_PACKET_SIZE);

  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;            // Stratum, or type of clock
  packetBuffer[2] = 6;            // Polling Interval
  packetBuffer[3] = 0xEC;         // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49;
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;

  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
  udp.beginPacket(address, 123);    //NTP requests are to port 123
  udp.write(packetBuffer, NTP_PACKET_SIZE);
  udp.endPacket();
}

//---------------------------------------------------------------------------
int send_ntp_request(void)
{
  int   o, m, s, n;
  int  cb;
  char s_w[40];

  ntp_request_active = true;
  
  if (DBG) sprintf(s_w, "send ntp request: %02d:%02d:%02d", ore, minuti, secondi);
  
  WiFi.hostByName(ntpServerName, timeServerIP);
  sendNTPpacket(timeServerIP);   

  // wait for ntp response
  for(n=0; n<20; n++)
  {
    cb = udp.parsePacket();
    if (cb) break;
    delay(500);
  }

  if (n == 20)  
  {
    ntp_request_active = false;
    return(0);
  } else {
    // response packet from the time server
    udp.read(packetBuffer, NTP_PACKET_SIZE);  
    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    unsigned long lowWord = word(packetBuffer[42], packetBuffer[43]);
    unsigned long secsSince1900 = highWord << 16 | lowWord;
    const unsigned long seventyYears = 2208988800UL;
    unsigned long epoch = secsSince1900 - seventyYears;

    o = (epoch  % 86400L) / 3600;
    m = (epoch  % 3600) / 60;  
    s = epoch % 60;

    ntp_request_active = false;
  
    // check the results... are they correct ?
    if ((o < 0) | (o > 24)) return(0);
    if ((m < 0) | (m > 60)) return(0);
    if ((s < 0) | (s > 60)) return(0);
    if ((o == 0) & (m == 0) & (s == 0)) return(0);
    
    ore = o; 
    minuti = m;
    secondi = s;     
    time_ok = true;  
    return(1);
   
  }
  
}
